org.licas.ws.wsdl.model

## Class WsdlOperation

- java.lang.Object
- - org.licas.ws.wsdl.model.WsdlOperation

-     public class WsdlOperation
      extends java.lang.Object

  This class describes an operation that can be called on a web service. As this is what the classes typically work with, the `commProtocol` is set to `WsdlConst`.`SOAP` by default.
  Author:
    Kieran Greer

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `WsdlOperation(WsdlModel theModel, java.lang.String thisName)` Create a new instance of WsdlOperation.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addParameter(WsdlParamInfo thisParam)` Add a parameter to one of the lists.
    `java.lang.Object` | `clone()` Get a clone of this object.
    `java.lang.String` | `getCommProtocol()` Get the communication protocol.
    `java.lang.String` | `getDocumentation()` Get the service documentation.
    `WsdlFault` | `getInFault()` Get the input fault value.
    `WsdlParamInfo` | `getInParamAt(java.lang.String baseName, int nestedCount)` Get a representation of the child input parameter at the specified nested position.
    `WsdlParamInfo` | `getInParameter(java.lang.String paramName)` Get the input parameter with the specified name.
    `java.util.ArrayList` | `getInParamNames()` Get the input parameter names list only.
    `java.util.ArrayList` | `getInParamNames(java.lang.String protocol)` Get the input parameter names list for the specified comm protocol.
    `java.util.HashMap` | `getInParams()` Get the input parameters.
    `java.util.HashMap` | `getInParams(java.lang.String protocol)` Get the input parameters for the specified comm protocol.
    `java.lang.String` | `getInputUse()` Get the input operation use.
    `java.util.ArrayList` | `getMethodInfoParams(java.lang.String protocol)` Get the input parameters for the specified comm protocol, for a `WsMethodInfo` object.
    `java.lang.String` | `getName()` Get the operation name.
    `WsdlFault` | `getOutFault()` Get the output fault value.
    `WsdlParamInfo` | `getOutParamAt(java.lang.String baseName, int nestedCount)` Get a representation of the child output parameter at the specified nested position.
    `WsdlParamInfo` | `getOutParameter(java.lang.String paramName)` Get the output parameter with the specified name.
    `java.util.ArrayList` | `getOutParamNames()` Get the output parameter names list only.
    `java.util.ArrayList` | `getOutParamNames(java.lang.String protocol)` Get the output parameter names list for the specified comm protocol.
    `java.util.HashMap` | `getOutParams()` Get the output parameters.
    `java.util.HashMap` | `getOutParams(java.lang.String protocol)` Get the output parameters for the specified comm protocol.
    `java.lang.String` | `getOutputUse()` Get the output operation use.
    `WsdlParamInfo` | `getParameter(java.lang.String paramName)` Get the parameter with the specified name.
    `java.lang.String` | `getPattern()` Get the operation pattern.
    `java.lang.String` | `getReturnType()` Guess what the return type is by parsing the output parameter list and returning the value of the first found 'return' parameter.
    `java.lang.String` | `getSoapAction()` Get the soap action description.
    `java.lang.String` | `getStyle()` Get the operation style.
    `void` | `messageTypePartsToParams()` Traverse all of the stored message and type parts in the model and convert them into empty parameter info elements as part of a complete nested structure.
    `void` | `setCommProtocol(java.lang.String thisCommProtocol)` Set the communication protocol.
    `void` | `setDocumentation(java.lang.String theDocumentation)` Set the description of the service.
    `void` | `setInFault(WsdlFault thisInFault)` Set the input fault value.
    `void` | `setInParams(java.util.HashMap thisInParams)` Set the input parameter values.
    `void` | `setInputUse(java.lang.String thisInputUse)` Set the input use for the operation.
    `void` | `setOutFault(WsdlFault thisOutFault)` Set the output fault value.
    `void` | `setOutParams(java.util.HashMap thisOutParams)` Set the output parameter values.
    `void` | `setOutputUse(java.lang.String thisOutputUse)` Set the output use for the operation.
    `void` | `setPattern(java.lang.String thisPattern)` Set the pattern for the operation.
    `void` | `setSoapAction(java.lang.String thisSoapAction)` Set the soap action for the operation.
    `void` | `setStyle(java.lang.String thisStyle)` Set the style for the operation.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WsdlOperation

          public WsdlOperation(WsdlModel theModel,
                               java.lang.String thisName)

      Create a new instance of WsdlOperation.
      Parameters:
        `theModel` - the complete parent wsdl model.
        `thisName` - the operation name.

  - ### Method Detail

    - #### getName

          public java.lang.String getName()

      Get the operation name.
      Returns:
        the value of name.

    - #### setDocumentation

          public void setDocumentation(java.lang.String theDocumentation)

      Set the description of the service.
      Parameters:
        `theDocumentation` - the service documentation.

    - #### getDocumentation

          public java.lang.String getDocumentation()

      Get the service documentation.
      Returns:
        the value of documentation.

    - #### setPattern

          public void setPattern(java.lang.String thisPattern)

      Set the pattern for the operation.
      Parameters:
        `thisPattern` - the pattern type.

    - #### getPattern

          public java.lang.String getPattern()

      Get the operation pattern.
      Returns:
        the value of pattern.

    - #### setStyle

          public void setStyle(java.lang.String thisStyle)

      Set the style for the operation.
      Parameters:
        `thisStyle` - the style type.

    - #### getStyle

          public java.lang.String getStyle()

      Get the operation style.
      Returns:
        the value of style.

    - #### setSoapAction

          public void setSoapAction(java.lang.String thisSoapAction)

      Set the soap action for the operation.
      Parameters:
        `thisSoapAction` - the soap action description.

    - #### getSoapAction

          public java.lang.String getSoapAction()

      Get the soap action description.
      Returns:
        the value of soapAction.

    - #### setCommProtocol

          public void setCommProtocol(java.lang.String thisCommProtocol)

      Set the communication protocol.
      Parameters:
        `thisCommProtocol` - the communication protocol.

    - #### getCommProtocol

          public java.lang.String getCommProtocol()

      Get the communication protocol.
      Returns:
        the value of commProtocol.

    - #### setInputUse

          public void setInputUse(java.lang.String thisInputUse)

      Set the input use for the operation.
      Parameters:
        `thisInputUse` - the operation use.

    - #### getInputUse

          public java.lang.String getInputUse()

      Get the input operation use.
      Returns:
        the value of inputUse.

    - #### setOutputUse

          public void setOutputUse(java.lang.String thisOutputUse)

      Set the output use for the operation.
      Parameters:
        `thisOutputUse` - the operation use.

    - #### getOutputUse

          public java.lang.String getOutputUse()

      Get the output operation use.
      Returns:
        the value of outputUse.

    - #### addParameter

          public void addParameter(WsdlParamInfo thisParam)

      Add a parameter to one of the lists.
      Parameters:
        `thisParam` - the input or output parameter.

    - #### getParameter

          public WsdlParamInfo getParameter(java.lang.String paramName)

      Get the parameter with the specified name. Can be either an input or an output parameter. The input list is checked first.
      Parameters:
        `paramName` - the parameter name.
      Returns:
        the parameter or null if none exist.

    - #### getInParameter

          public WsdlParamInfo getInParameter(java.lang.String paramName)

      Get the input parameter with the specified name.
      Parameters:
        `paramName` - the parameter name.
      Returns:
        the parameter or null if none exist.

    - #### getOutParameter

          public WsdlParamInfo getOutParameter(java.lang.String paramName)

      Get the output parameter with the specified name.
      Parameters:
        `paramName` - the parameter name.
      Returns:
        the parameter or null if none exist.

    - #### getReturnType

          public java.lang.String getReturnType()

      Guess what the return type is by parsing the output parameter list and returning the value of the first found 'return' parameter.
      Returns:
        likely return value type.

    - #### getInParamAt

          public WsdlParamInfo getInParamAt(java.lang.String baseName,
                                            int nestedCount)

      Get a representation of the child input parameter at the specified nested position. The search is performed depth first, or child elements before sibling elements. The nested or complex structures are originally stored as WsdlMessage objects. If the parameter at the specified index is missing, then it is retrieved from the WsdlModel message object list instead.
      Parameters:
        `baseName` - the name of the base or top-most parameter to parse.
        `nestedCount` - the final count position. The very first parameter has a value of 0 and its first child part, or the next part, the value of 1.
      Returns:
        the child element if at this level, or null if not.

    - #### getOutParamAt

          public WsdlParamInfo getOutParamAt(java.lang.String baseName,
                                             int nestedCount)

      Get a representation of the child output parameter at the specified nested position. The search is performed depth first, or child elements before sibling elements. The nested or complex structures are originally stored as WsdlMessage objects. If the parameter at the specified index is missing, then it is retrieved from the WsdlModel message object list instead.
      Parameters:
        `baseName` - the name of the base or top-most parameter to parse.
        `nestedCount` - the final count position. The very first parameter has a value of 0 and its first child part, or the next part, the value of 1.
      Returns:
        the child element if at this level, or null if not.

    - #### messageTypePartsToParams

          public void messageTypePartsToParams()

      Traverse all of the stored message and type parts in the model and convert them into empty parameter info elements as part of a complete nested structure. This should be called only once.

    - #### setInParams

          public void setInParams(java.util.HashMap thisInParams)

      Set the input parameter values.
      Parameters:
        `thisInParams` - the set of input parameters.

    - #### getInParamNames

          public java.util.ArrayList getInParamNames()

      Get the input parameter names list only.
      Returns:
        a list of the input parameters names only.

    - #### getInParamNames

          public java.util.ArrayList getInParamNames(java.lang.String protocol)

      Get the input parameter names list for the specified comm protocol.
      Parameters:
        `protocol` - the protocol type - SOAP, GET or POST
      Returns:
        list of parameter names only that end with the defined protocol ending.

    - #### getInParams

          public java.util.HashMap getInParams()

      Get the input parameters.
      Returns:
        the value of inParams.

    - #### getInParams

          public java.util.HashMap getInParams(java.lang.String protocol)

      Get the input parameters for the specified comm protocol.
      Parameters:
        `protocol` - the protocol type - SOAP, GET or POST
      Returns:
        the value of inParams that end with the defined protocol ending.

    - #### getMethodInfoParams

          public java.util.ArrayList getMethodInfoParams(java.lang.String protocol)

      Get the input parameters for the specified comm protocol, for a `WsMethodInfo` object.
      Parameters:
        `protocol` - the protocol type - SOAP, GET or POST.
      Returns:
        the list of input parameters as `WsdlParamInfo` objects.

    - #### setOutParams

          public void setOutParams(java.util.HashMap thisOutParams)

      Set the output parameter values.
      Parameters:
        `thisOutParams` - the set of output parameters.

    - #### getOutParamNames

          public java.util.ArrayList getOutParamNames()

      Get the output parameter names list only.
      Returns:
        a list of the output parameters names only.

    - #### getOutParamNames

          public java.util.ArrayList getOutParamNames(java.lang.String protocol)

      Get the output parameter names list for the specified comm protocol.
      Parameters:
        `protocol` - the protocol type - SOAP, GET or POST
      Returns:
        list of parameter names only that end with the defined protocol ending.

    - #### getOutParams

          public java.util.HashMap getOutParams()

      Get the output parameters.
      Returns:
        the value of outParams.

    - #### getOutParams

          public java.util.HashMap getOutParams(java.lang.String protocol)

      Get the output parameters for the specified comm protocol.
      Parameters:
        `protocol` - the protocol type - SOAP, GET or POST
      Returns:
        the value of outParams that end with the defined protocol ending.

    - #### setInFault

          public void setInFault(WsdlFault thisInFault)

      Set the input fault value.
      Parameters:
        `thisInFault` - the input fault description.

    - #### getInFault

          public WsdlFault getInFault()

      Get the input fault value.
      Returns:
        the value of inFault.

    - #### setOutFault

          public void setOutFault(WsdlFault thisOutFault)

      Set the output fault value.
      Parameters:
        `thisOutFault` - the output fault description.

    - #### getOutFault

          public WsdlFault getOutFault()

      Get the output fault value.
      Returns:
        the value of outFault.

    - #### clone

          public java.lang.Object clone()

      Get a clone of this object. This is a deep clone, but not 100% guaranteed.
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        a clone copy of this object, without the fault information.